﻿/*

PathCompact_C.prg

Functions:
  GetCompactPathChar(cPath, nChars)
  GetCompactPathPix(cPath, nPixels, nHWnd)
are written in C

*/

#include 'hmg.ch'

FUNCTION Main()

  SET FONT TO 'MS Shell Dlg', 8

  DEFINE WINDOW MainWA;
    MAIN;
    WIDTH  400;
    HEIGHT 255;
    TITLE  'Path Compact';
    NOMAXIMIZE;
    NOSIZE

    DEFINE LABEL PathLA
      ROW     10
      COL     10
      WIDTH  370
      HEIGHT  13
      VALUE  'Path to compact:'
    END LABEL

    DEFINE TEXTBOX PathTE
      ROW        25
      COL        10
      WIDTH     370
      HEIGHT     20
      MAXLENGTH 259
      VALUE     GetProcessFullName()
      FONTNAME  'MS Shell Dlg'
      FONTSIZE  8
      ONCHANGE  CompactPaths()
    END TEXTBOX

    DEFINE LABEL CompCharLA
      ROW     55
      COL     10
      WIDTH  370
      HEIGHT  13
      VALUE  'Compact path - length in characters:'
    END LABEL

    DEFINE TEXTBOX CompCharTE
      ROW        70
      COL        10
      WIDTH     330
      HEIGHT     20
      MAXLENGTH 259
      READONLY  .T.
      DISABLEDBACKCOLOR {224, 224, 224}
      ONGOTFOCUS SendMessage(MainWA.CompCharTE.HANDLE, 177 /*EM_SETSEL*/, 0, -1)
    END TEXTBOX

    DEFINE TEXTBOX CharsTE
      ROW         70
      COL        350
      WIDTH       30
      HEIGHT      20
      VALUE       30
      DATATYPE   NUMERIC
      RIGHTALIGN .T.
      INPUTMASK  '999'
      ONCHANGE   CompactPaths()
    END TEXTBOX

    DEFINE LABEL CompPixLA
      ROW    100
      COL     10
      WIDTH  370
      HEIGHT  13
      VALUE  'Compact path - length in pixels:'
    END LABEL

    DEFINE TEXTBOX CompPixTE
      ROW       115
      COL        10
      WIDTH     330
      HEIGHT     20
      MAXLENGTH 259
      READONLY  .T.
      DISABLEDBACKCOLOR {224, 224, 224}
      ONGOTFOCUS SendMessage(MainWA.CompPixTE.HANDLE, 177 /*EM_SETSEL*/, 0, -1)
    END TEXTBOX

    DEFINE TEXTBOX PixelsTE
      ROW        115
      COL        350
      WIDTH       30
      HEIGHT      20
      VALUE      120
      DATATYPE   NUMERIC
      INPUTMASK  '999'
      RIGHTALIGN .T.
      ONCHANGE   CompactPaths()
    END TEXTBOX

    DEFINE LABEL CompWndLA
      ROW    145
      COL     10
      WIDTH  370
      HEIGHT  13
      VALUE  'Compact path to control width:'
    END LABEL

    DEFINE TEXTBOX CompWndTE
      ROW       160
      COL        10
      WIDTH     330
      HEIGHT     20
      MAXLENGTH 259
      READONLY  .T.
      DISABLEDBACKCOLOR {224, 224, 224}
      ONGOTFOCUS SendMessage(MainWA.CompWndTE.HANDLE, 177 /*EM_SETSEL*/, 0, -1)
    END TEXTBOX

    DEFINE TEXTBOX WidthTE
      ROW        160
      COL        350
      WIDTH       30
      HEIGHT      20
      VALUE      160
      DATATYPE   NUMERIC
      INPUTMASK  '999'
      RIGHTALIGN .T.
      ONCHANGE   (MainWA.CompWndTE.WIDTH := If(MainWA.WidthTE.VALUE < 0, 0, MainWA.WidthTE.VALUE), CompactPaths())
    END TEXTBOX

    DEFINE BUTTON DirBU
      ROW     190
      COL      10
      WIDTH    70
      HEIGHT   23
      CAPTION '&Directory'
      ACTION  SetDir()
    END BUTTON

    DEFINE BUTTON FileBU
      ROW     190
      COL      90
      WIDTH    70
      HEIGHT   23
      CAPTION '&File'
      ACTION  SetFile()
    END BUTTON

    DEFINE BUTTON FontBU
      ROW     190
      COL     170
      WIDTH    70
      HEIGHT   23
      CAPTION 'F&ont'
      ACTION  SetFont()
    END BUTTON

    DEFINE LABEL FontLA
      ROW    195
      COL    250
      WIDTH  120
      HEIGHT  13
      VALUE  MainWA.PathTE.FONTNAME + ', ' + LTrim(Str(MainWA.PathTE.FONTSIZE))
    END LABEL

    ON KEY ESCAPE ACTION MainWA.RELEASE

  END WINDOW

  MainWA.CENTER
  MainWA.ACTIVATE

RETURN NIL


FUNCTION SetDir()
  LOCAL cFolder := GetFolder('Select folder:', MainWA.PathTE.VALUE)

  IF ! Empty(cFolder)
    MainWA.PathTE.VALUE := cFolder
  ENDIF

RETURN NIL


FUNCTION SetFile()
  LOCAL cFile := GetFile({{'*.*', '*.*'}}, 'Select file')

  IF ! Empty(cFile)
    MainWA.PathTE.VALUE := cFile
  ENDIF

RETURN NIL


FUNCTION SetFont()
  LOCAL aFont := GetFont(MainWA.PathTE.FONTNAME, MainWA.PathTE.FONTSIZE, MainWA.PathTE.FONTBOLD, MainWA.PathTE.FONTITALIC, NIL, MainWA.PathTE.FONTUNDERLINE, MainWA.PathTE.FONTSTRIKEOUT, DEFAULT_CHARSET)

  IF ! Empty(aFont[1])
    MainWA.PathTE.FONTNAME      := aFont[1]
    MainWA.PathTE.FONTSIZE      := aFont[2]
    MainWA.PathTE.FONTBOLD      := aFont[3]
    MainWA.PathTE.FONTITALIC    := aFont[4]
    MainWA.PathTE.FONTUNDERLINE := aFont[6]
    MainWA.PathTE.FONTSTRIKEOUT := aFont[7]

    MainWA.CompCharTE.FONTNAME      := aFont[1]
    MainWA.CompCharTE.FONTSIZE      := aFont[2]
    MainWA.CompCharTE.FONTBOLD      := aFont[3]
    MainWA.CompCharTE.FONTITALIC    := aFont[4]
    MainWA.CompCharTE.FONTUNDERLINE := aFont[6]
    MainWA.CompCharTE.FONTSTRIKEOUT := aFont[7]

    MainWA.CompPixTE.FONTNAME      := aFont[1]
    MainWA.CompPixTE.FONTSIZE      := aFont[2]
    MainWA.CompPixTE.FONTBOLD      := aFont[3]
    MainWA.CompPixTE.FONTITALIC    := aFont[4]
    MainWA.CompPixTE.FONTUNDERLINE := aFont[6]
    MainWA.CompPixTE.FONTSTRIKEOUT := aFont[7]

    MainWA.CompWndTE.FONTNAME      := aFont[1]
    MainWA.CompWndTE.FONTSIZE      := aFont[2]
    MainWA.CompWndTE.FONTBOLD      := aFont[3]
    MainWA.CompWndTE.FONTITALIC    := aFont[4]
    MainWA.CompWndTE.FONTUNDERLINE := aFont[6]
    MainWA.CompWndTE.FONTSTRIKEOUT := aFont[7]

    MainWA.FontLA.VALUE := MainWA.PathTE.FONTNAME + ', ' + LTrim(Str(MainWA.PathTE.FONTSIZE))

    CompactPaths()
  ENDIF

RETURN NIL


FUNCTION CompactPaths()

  IF IsControlDefined(CompCharTE, MainWA)
    MainWA.CompCharTE.VALUE := GetCompactPathChar(MainWA.PathTE.VALUE, MainWA.CharsTE.VALUE)
  ENDIF

  IF IsControlDefined(CompPixTE, MainWA)
    MainWA.CompPixTE.VALUE := GetCompactPathPix(MainWA.PathTE.VALUE, MainWA.PixelsTE.VALUE, MainWA.CompPixTE.HANDLE)
  ENDIF

  IF IsControlDefined(CompWndTE, MainWA)
    MainWA.CompWndTE.VALUE := GetCompactPathPix(MainWA.PathTE.VALUE, GetClientAreaWidth(MainWA.CompWndTE.HANDLE), MainWA.CompWndTE.HANDLE)
  ENDIF

RETURN NIL


#pragma BEGINDUMP
  #include "SET_COMPILE_HMG_UNICODE.ch"
  #include "HMG_UNICODE.h"

  #include <windows.h>
  #include <shlwapi.h>
  #include "hbapi.h"

          //GetCompactPathChar(cPath, nChars) -> cCompactPath
  HB_FUNC ( GETCOMPACTPATHCHAR )
  {
    LPCTSTR pszSrc = (LPCTSTR) HMG_parc(1);
    INT     ccMax  = (INT)     hb_parni(2) + 1;

    if (ccMax < 1)
      ccMax = 1;
    else if (ccMax > MAX_PATH)
      ccMax = MAX_PATH;

    TCHAR pszOut[ccMax];

    PathCompactPathEx(pszOut, pszSrc, ccMax, 0);

    HMG_retc(pszOut);
  }

          //GetCompactPathPix(cPath, nPixels, nHWnd) -> cCompactPath
  HB_FUNC ( GETCOMPACTPATHPIX )
  {
    LPTSTR lpszPath = (LPTSTR) HMG_parc (1);
    INT    dx       = (INT)    hb_parni (2);
    HWND   hWnd     = (HWND)   HMG_parnl(3);
    HDC    hDC      = GetDC(hWnd);
    HFONT  hFont    = SelectObject(hDC, (HFONT) SendMessage(hWnd, WM_GETFONT, 0, 0));

    if (dx < 0)
      dx = 0;

    PathCompactPath(hDC, lpszPath, dx);

    SelectObject(hDC, hFont);
    ReleaseDC(hWnd, hDC);
    HMG_retc(lpszPath);
  }

#pragma ENDDUMP
